#! /usr/local/bin/bash
#
#	simulatom-0.2/.outil.bash
#
#	Script de gestion d'environnement de l'application SimulAtom v0.2
#
#HISTORY:
# 2003/12/01 - MD : Creation
#HISTORY

version=0.2

# IUP de Vannes
#basedir=/home/etud/projets/lsir01/prosir4

#Yann Le Guyadec
#basedir=/usr/local/produits

#IUT de Vannes
#basedir=/usr/local/alt/produits

#Michel DUBOIS
basedir=/home/simulatom

function rmpath() {
# remove the directories 'dirs' from the path 'the_path' ; return the modified
# path un 'the_path'. Used by 'stop' section
#
    for dir in $dirs; do
    	e1="s+${dir}++g"
	newPath=`echo ${the_path} | sed -e "$e1"`
	the_path=${newPath}
    done
    newPath=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
    the_path=${newPath}
    ##echo "newPath=$the_path"  
} # -------------------------------------------------- rmpath()

	_command=$0
	_operator=$1
	_outil=$2
	shift
	shift

    case ${_operator} in
	"+"|"start")
	    #
	    # Chargement de l'environnement 
	    # - definition des variables d'environnement
	    #
	    if [ -z ${SIMULATOMHOME} ]; then

		source ${basedir}/simulatom-${version}/setup.bash
		echo "Environnement de l'application "\"${_outil}\"" charge..."
	    else
		echo "Environnement de l'application "\"${_outil}\"" deja charge..."
	    fi;;

	"-"|"stop")
	    #
	    # Dechargement de l'environnement  :
	    # - suppression des chemins dans PATH
	    # - suppression des chemins dans LD_LIBRARY_PATH
	    # - suppression des chemins dans MANPATH
	    # - suppression des variables 
	    #
	    if [ -z ${SIMATOMHOME} ]; then
	        echo "Environnement de l'application "\"${_outil}\"" non charge"
	    else
	        # nettoie le PATH
		dirs="${SIMATOMHOME}/bin"
		the_path=${PATH} ; rmpath
		export PATH=$the_path
		dirs="${SIMATOMHOME}/lib"
		the_path=${LD_LIBRARY_PATH} ; rmpath
		export LD_LIBRARY_PATH=$the_path
		dirs="${SIMATOMHOME}/man"
		the_path=${MANPATH} ; rmpath
		export MANPATH=$the_path
		unset SIMATOMMODE SIMATOMCONFIG SIMATOMHOME
		echo "Environnement de l'application "\"${_outil}\"" decharge..."
	    fi
	    if [ ! -z ${UBERSIMHOME} ]; then
	        # nettoie le PATH
		dirs="${UBERSIMHOME}/bin"
		the_path=${PATH} ; rmpath
		export PATH=$the_path
		dirs="${UBERSIMHOME}/lib"
		the_path=${LD_LIBRARY_PATH} ; rmpath
		export LD_LIBRARY_PATH=$the_path
		unset UBERSIMCONFIG UBERSIMHOME
	    fi
	    if [ ! -z ${ODEHOME} ]; then
	        # nettoie le PATH
		dirs="${ODEHOME}/bin"
		the_path=${PATH} ; rmpath
		export PATH=$the_path
		dirs="${ODEHOME}/lib"
		the_path=${LD_LIBRARY_PATH} ; rmpath
		export LD_LIBRARY_PATH=$the_path
		unset ODEHOME
	    fi
	    if [ ! -z ${MPEG_ENCODEHOME} ]; then
	        # nettoie le PATH
		dirs="${MPEG_ENCODEHOME}/bin"
		the_path=${PATH} ; rmpath
		export PATH=$the_path
		dirs="${MPEG_ENCODEHOME}/man"
		the_path=${MANPATH} ; rmpath
		export MANPATH=$the_path
		unset MPEG_ENCODEHOME
	    fi
	    if [ ! -z ${SMPEGHOME} ]; then
	        # nettoie le PATH
		dirs="${SMPEGHOME}/bin"
		the_path=${PATH} ; rmpath
		export PATH=$the_path
		dirs="${SMPEGHOME}/man"
		the_path=${MANPATH} ; rmpath
		export MANPATH=$the_path
		unset SMPEGHOME
	    fi
	    if [ ! -z ${EEHOME} ]; then
	        # nettoie le PATH
		dirs="${EEHOME}/bin"
		the_path=${PATH} ; rmpath
		export PATH=$the_path
		unset EEHOME
	    fi;;



	"help")
	#
	# Aide en ligne pour le script d'environnement Sas v8.2
	#
		echo "Usage: outil { + | - } "\"${_outil}\"
		echo "       outil { help | start | stop } "\"${_outil}\"
		echo ""
		echo "      help  : aide en ligne"
		echo "  + | start : installe l'environnement pour "\"${_outil}\"
		echo "  - | stop  : supprime l'environnement pour "\"${_outil}\";;

	*)
	#
	# Erreur d'appel du script de gestion d'environnement
	# pour Sas v8.2
	#
		echo "outil: operateur incorrect: "\"${_operator}\"
		echo "essayez "\""outil help "${_outil}\"" pour obtenir de l'aide";;
	esac

	unset _command _operator _outil
