#! /usr/local/bin/tcsh
#
#	simulatom-0.2/.outil.tcsh
#
#	Script de gestion d'environnement de l'application SimulAtom v0.2
#
#HISTORY:
# 2003/12/01 - MD : Creation
#HISTORY

set version=0.2

# IUP de Vannes
#set basedir=/home/etud/projets/lsir01/prosir4
# IUT de Vannes
#set basedir=/usr/local/alt/produits
# Michel Dubois
set basedir=/home/simulatom
# Yann Le Guyadec
#set basedir=/usr/local/produits


    set _command=$0
    set _operator=$1
    set _outil=$2
    shift
    shift

    switch ( ${_operator} )
	case "+":
	case "start":
	    #
	    # Chargement de l'environnement 
	    # - definition des variables d'environnement
	    #
	    if ( ${?SIMATOMHOME} ) then
		echo "Environnement de l'application "\"${_outil}\"" deja charge..."
	    else
		source ${basedir}/simulatom-${version}/setup.tcsh
		echo "Environnement de l'application "\"${_outil}\"" charge..."
	    endif
	    breaksw

	case "-":
	case "stop":
	    #
	    # Dechargement de l'environnement  :
	    # - suppression des chemins dans PATH
	    # - suppression des chemins dans LD_LIBRARY_PATH
	    # - suppression des chemins dans MANPATH
	    # - suppression des variables 
	    #
	    if ( ${?SIMATOMHOME} ) then
	        # nettoie le PATH
	        set the_path=${PATH}
	        foreach dir (${SIMATOMHOME}/bin)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv PATH $np
	        # nettoie le LD_LIBRARY_PATH
	        set the_path=${LD_LIBRARY_PATH}
	        foreach dir (${SIMATOMHOME}/lib)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv LD_LIBRARY_PATH $np
	        # nettoie le MANPATH
	        set the_path=${MANPATH}
	        foreach dir (${SIMATOMHOME}/man)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv MANPATH $np

		unsetenv SIMATOMMODE SIMATOMCONFIG SIMATOMHOME

		echo "Environnement de l'application "\"${_outil}\"" decharge..."
	    else
		echo "Environnement de l'application "\"${_outil}\"" non charge..."
	    endif
	    if ( ${?UBERSIMHOME} ) then
	        # nettoie le PATH
	        set the_path=${PATH}
	        foreach dir (${UBERSIMHOME}/bin)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv PATH $np
	        # nettoie le LD_LIBRARY_PATH
	        set the_path=${LD_LIBRARY_PATH}
	        foreach dir (${UBERSIMHOME}/lib)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv LD_LIBRARY_PATH $np
		unsetenv UBERSIMCONFIG UBERSIMHOME
	    endif

	    if ( ${?ODEHOME} ) then
	        # nettoie le PATH
	        set the_path=${PATH}
	        foreach dir (${ODEHOME}/bin)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv PATH $np
	        # nettoie le LD_LIBRARY_PATH
	        set the_path=${LD_LIBRARY_PATH}
	        foreach dir (${ODEHOME}/lib)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv LD_LIBRARY_PATH $np
		unsetenv ODEHOME
	    endif
	    if ( ${?MPEG_ENCODEHOME} ) then
	        # nettoie le PATH
	        set the_path=${PATH}
	        foreach dir (${MPEG_ENCODEHOME}/bin)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv PATH $np
	        # nettoie le MANPATH
	        set the_path=${MANPATH}
	        foreach dir (${MPEG_ENCODEHOME}/man)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv MANPATH $np
		unsetenv MPEG_ENCODEHOME
	    endif
	    if ( ${?SMPEGHOME} ) then
	        # nettoie le PATH
	        set the_path=${PATH}
	        foreach dir (${SMPEGHOME}/bin)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv PATH $np
	        # nettoie le MANPATH
	        set the_path=${MANPATH}
	        foreach dir (${SMPEGHOME}/man)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv MANPATH $np
		unsetenv SMPEGHOME
	    endif
	    if ( ${?EEHOME} ) then
	        # nettoie le PATH
	        set the_path=${PATH}
	        foreach dir (${EEHOME}/bin)
	            set e1="s+${dir}++g"
		    set np=`echo ${the_path} | sed -e "$e1"`
		    set the_path=$np
                end
		set np=`echo ${the_path} | sed -e 's/::/:/g' | sed -e 's/^://'`
		setenv PATH $np
		unsetenv EEHOME
	    endif

	    breaksw

	case "help":
	    #
	    # Aide en ligne pour le script d'environnement jdk1.3.1
	    #
	    echo "Usage: outil { + | - } "\"${_outil}\"
	    echo "       outil { help | start | stop } "\"${_outil}\"
	    echo ""
	    echo "      help  : aide en ligne"
	    echo "  + | start : installe l'environnement pour "\"${_outil}\"
	    echo "  - | stop  : supprime l'environnement pour "\"${_outil}\";;
	    breaksw

	default:
	    #
	    # Erreur d'appel du script de gestion d'environnement
	    # pour 
	    #
	    echo "outil: operateur incorrect: "\"${_operator}\"
	    echo "essayez "\""outil help "${_outil}\"" pour obtenir de l'aide";;
	    endsw

    unset _command _operator _outil _say
