/***************************************************************************
                          AMotorJoint.h  -  description
                             -------------------
    begin                : mar fv 18 2003
    copyright            : (C) 2003 by Yann Le Guyadec, Michel DUBOIS
    email                : Yann.Le-Guyadec@univ-ubs.fr, Michel.Dubois@univ-ubs.fr 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AMOTORJOINT_H
#define AMOTORJOINT_H

#include "SimJoint.h"
#include "Vector3.h"
#include "Graph.h"
#include "Controller.h"
#include <stdio.h>

/**
  *@author Yann Le Guyadec, Michel DUBOIS
  */

/**
  * changes :
  *  - 22/6/03 MD N'herite plus de Joint !
  */
      
class AMotorJoint : public SimJoint{

  public: 
	AMotorJoint(SimRigidBody * rigidBody1, SimRigidBody * RigidBody2);
	virtual ~AMotorJoint();
		void set (char * name, char * value);
    void setAxis          (const int axis, const Vector3& axis1);
    void setParam (const int parameter,const Real value);
    void setMode (int mode);
    void setNumAxes (int num);
    Real getParam (int parameter) const;
    SimRigidBody * getRigidBody1 () const;
		SimRigidBody * getRigidBody2 () const;
    void print() const;    

};

class AMotor : public Connection, Controller{

  public:
	AMotor(SimRigidBody * rigidBody1, SimRigidBody * RigidBody2);
	virtual ~AMotor();
		void set (char * name, char * value);
    void setAxis          (const int axis, const Vector3& axis1);
    void setParam (const int parameter,const Real value);
    void setMode (int mode);
    void setNumAxes (int num);
    Real getParam (int parameter) const;
    SimRigidBody * getRigidBody1 () const;
		SimRigidBody * getRigidBody2 () const;
    void swap();
    void print() const;
    void setIsEnabled(bool isEnabled);


	protected:
		SimRigidBody * rigidBody1;
		SimRigidBody * rigidBody2;
		dJointID joint;


};

#endif
