/***************************************************************************
                          Edge.h  -  description
                             -------------------
    begin                : lun jui 14 2003
    copyright            : (C) 2003 by Michel Dubois, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EDGE_H
#define EDGE_H

#include "Link.h"
#include "Atom.h"
#include "Molecule.h"
#include "nommgr.h"
#include <vector>
#include "mmgr.h"


namespace API {
  class Link;
  class Molecule;
  class Atom;
/**
  *@author Yann Le Guyadec, Michel DUBOIS
  */

  class Edge {
    private:
      std::vector<Link *> links;
      Atom * atom1;
      Atom * atom2;
      Molecule * molecule;
    public:
      Edge(Atom * anAtom, Atom * anotherAtom);
	    ~Edge();
      Link * getLink(unsigned int index);
      Molecule * getMolecule();
  //  SimLink * getSimulatedObject();
      int getLinkIndex (Link * aLink) const;
      unsigned int getLinkCount() const;
      void addLink(Link * aLink);
      void removeLink(Link * aLink);
      void swap();
      void print() const;

    protected:
      void setMolecule(Molecule * aMolecule);
//  friend class Molecule;
  };

}

#endif
