/***************************************************************************
                          ForceSensor.h  -  description
                             -------------------
    begin                : mer jun 08 2003
    copyright            : (C) 2003 by Yann Le Guyadec, Michel DUBOIS
    email                : Yann.Le-Guyadec@univ-ubs.fr, Michel.Dubois@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
  * changes :
  *  - 08/06/03 MD Creation !
  */


#ifndef __FORCESENSOR__
#define __FORCESENSOR__


// Include files
#include "Sensor.h"
#include "Leg.h"
namespace API {
  class Leg;
/**
* Classe definissant un capteur d'effort
*
*@author Michel Dubois, Yann Le Guyadec
*@version du 08/06/03 (08 juin 2003)
*@since 0.2
*/
  class ForceSensor : public Sensor
  {
    public:
    
/**
	* retourne la force percue par le capteur d'effort courant
  *
  * @return la force percue par le capteur d'effort en newton
	*/
      double toNewton() const;

/**
	* retourne la reference de la patte du capteur d'effort courant
	*
	* @return l'instance de la patte qui est concernee par le capteur d'effort
  	*/
      Leg * getLeg() const;
      
	/**
	* retourne l'identifiant du capteur d'effort courant
	*
	* @return le numero du capteur d'effort
  	*/
      unsigned int getID() const;

    protected :

/**
	* constructeur d'un capteur d'effort
	*
	*/
      ForceSensor();
      
/**
	* destructeur d'un capteur de contact
	*
	*/
      virtual ~ForceSensor();

/**
	* affecte la patte proprietaire du capteur de contact courant
	* @param aLeg reference du capteur de contact
	*/
      void setLeg(Leg * aLeg);
      
	/**
	* retourne l'identifiant du capteur d'effort courant
	*
	* @return le numero du capteur d'effort
  	*/
      void setID(unsigned int aForceSensorID);

    private :
      Leg * leg;
      unsigned int ID;

  
  };// END CLASS DEFINITION ForceSensor
}
#endif // __FORCESENSOR__
