/***************************************************************************
                          SimAtom.h  -  description
                             -------------------
    begin                : mer jun 25 2003
    copyright            : (C) 2003 by Yann Le Guyadec, Michel DUBOIS
    email                : Yann.Le-Guyadec@univ-ubs.fr, Michel.Dubois@univ-ubs.fr 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SIMATOM_H
#define SIMATOM_H

#include "SimLeg.h"
#include "RigidBody.h"
#include "RigidBodyEntity.h"
#include "HingeJoint.h"
#include "AMotorJoint.h"
#include "Matrix22.h"
#include "Vector2.h"
#include "Vector3.h"
#include "SphereGeometry.h"
#include "RigidBodyCollider.h"
#include "CappedCylinderGeometry.h"
#include "Atom.h"
//#include "Graph.h"

class SimLeg;
/**
  *@author Yann Le Guyadec, Michel DUBOIS
  */

class SimAtom : public RigidBodyEntity  {
  friend class SimLeg;
  private :
    unsigned int ID;
    SimLeg * legs[6];  
    RigidBodyCollider * kernelCollider;
    static std::string showaabb;
    static std::string showcontacts;
  public: 
	  SimAtom();  
    virtual ~SimAtom();
    unsigned int getSimLegCount() const;
    SimLeg * getSimLeg(unsigned int SimLegID) const;    
    RigidBody * getKernel() const;
    void SimAtom::handleEvent (Event* event);
    unsigned int getID() const;
    void setID(unsigned int anAtomID);
    virtual void print();
    Vector3 getPosition();


};

#endif
