/***************************************************************************
                          SimIsland.h  -  description
                             -------------------
    begin                : mar jui 29 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec 
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SIMISLAND_H
#define SIMISLAND_H
/*
#include "nommgr.h"
#include <vector>
#include "mmgr.h"
*/
#include "Island.h"
#include "Graph.h"
#include "Controller.h"
#include "SimRigidBody.h"

/**
  *@author Michel DUBOIS, Yann Le Guyadec 
  */

class SimRigidBody;

class SimIsland : public Island, public Graph, public Controller  {
public: 
	SimIsland();
	~SimIsland();
  void destroyGraph(Graph * aGraph);
  Graph * createGraph ();
  void setIsEnabled (const bool isEnabled);
  SimRigidBody* getSimRigidBody (unsigned int index);
  RigidBody* getRigidBody (unsigned int index);
  unsigned int getRigidBodyCount ();
  void addRigidBody (RigidBody* rigidBody);
  void removeRigidBody (RigidBody* rigidBody);
  RigidBody* removeRigidBody (unsigned int i);
  void addSimRigidBody (SimRigidBody* rigidBody);
  void removeSimRigidBody (SimRigidBody* rigidBody);
  SimRigidBody* removeSimRigidBody (unsigned int i);
  void synchronize();
  void print();
  unsigned int size ();
protected :
/*

  std::vector <RigidBody *> rigidBodies;
  unsigned int rigidBodyCount;
*/
};

#endif
