/***************************************************************************
                          SimMolecule.h  -  description
                             -------------------
    begin                : mer jun 25 2003
    copyright            : (C) 2003 by Yann Le Guyadec, Michel DUBOIS
    email                : Yann.Le-Guyadec@univ-ubs.fr, Michel.Dubois@univ-ubs.fr 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SIMMOLECULE_H
#define SIMMOLECULE_H

#include <RigidBodyEntity.h>
#include "SimAtom.h"
#include "CollisionGroup.h"

/**
  *@author Yann Le Guyadec, Michel DUBOIS
  */

class SimAtom;

class SimMolecule : public RigidBodyEntity  {
public: 
	SimMolecule();
	~SimMolecule();
  virtual void print();
  void addAtom( SimAtom * atom);
  void removeAtom( SimAtom * atom);
  void handleEvent (Event* event);
  static void setCollisionGroup(CollisionGroup * aCollisionGroup);
protected :
  static CollisionGroup * collisionGroup;
};

#endif
