/***************************************************************************
                          amotorjoint.cpp  -  description
                             -------------------
    begin                : mar fv 18 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/**
  * changes :
  *  - 15/6/03 MD Creation !
  */
 


#include <ode/ode.h>

#include "mmgr.h"

#include "AMotorJoint.h"
#include "Simulator.h"
#include "RigidBody.h"

/*
RigidBody* AMotor::getRigidBody1 () const
{
	return rigidBody1;
}

RigidBody* AMotor::getRigidBody2 () const
{
	return rigidBody2;
}
*/

AMotorJoint::AMotorJoint (SimRigidBody* rigidBody1, SimRigidBody* rigidBody2) : SimJoint(rigidBody1, rigidBody2)
{
  this->rigidBody1 = rigidBody1;
	this->rigidBody2 = rigidBody2;
  
  joint = dJointCreateAMotor (Simulator::getInstance ()->getWorld (), 0);
	dJointAttach (joint, rigidBody1->getBody (), rigidBody2->getBody ());

	dJointSetAMotorParam (joint, dParamLoStop,  0.0);
	dJointSetAMotorParam (joint, dParamHiStop,  0.0);
	dJointSetAMotorParam (joint, dParamVel,     0.0);
	//dJointSetAMotorParam (joint, dParamStopCFM, 0.5);
	//dJointSetAMotorParam (joint, dParamStopERP, 0.9);
	dJointSetAMotorParam (joint, dParamFMax,    dInfinity);
}

void AMotorJoint::set (char* name, char* value)
{

}
void AMotorJoint::print () const
{
  printf ("AMotorJoint:\n");
  SimJoint::print ();
}

/*
void AMotorJoint::setAnchor (const Vector3& anchor)
{
	dJointSetAMotorAnchor (joint, anchor.x, anchor.y, anchor.z);
}
*/

void AMotorJoint::setAxis (const int parameter, const Vector3& axis)
{
	dJointSetAMotorAxis (joint, parameter,1, axis.x, axis.y, axis.z);
}


void AMotorJoint::setParam (int parameter, Real value)
{
  dJointSetAMotorParam (joint, parameter, value);
  

}

void AMotorJoint::setNumAxes (int num)
{
  dJointSetAMotorNumAxes (joint, num);
}

void AMotorJoint::setMode (int mode)
{
  dJointSetAMotorMode (joint, mode);
}  

Real AMotorJoint::getParam (int parameter) const
{
 return dJointGetAMotorParam(joint, parameter);
}


AMotorJoint::~AMotorJoint(){
}


SimRigidBody* AMotor::getRigidBody1 () const
{
	return rigidBody1;
}

SimRigidBody* AMotor::getRigidBody2 () const
{
	return rigidBody2;
}

AMotor::AMotor (SimRigidBody* rigidBody1, SimRigidBody* rigidBody2) : Connection(rigidBody1, rigidBody2), Controller()
{
  this->rigidBody1 = rigidBody1;
	this->rigidBody2 = rigidBody2;
//  this->getVertex1()->getGraph()->insertConnection(this);

  joint = dJointCreateAMotor (Simulator::getInstance ()->getWorld (), 0);

	dJointAttach (joint, rigidBody1->getBody (), rigidBody2->getBody ());

	dJointSetAMotorParam (joint, dParamLoStop,  0.0);
	dJointSetAMotorParam (joint, dParamHiStop,  0.0);
	dJointSetAMotorParam (joint, dParamVel,     0.0);
	//dJointSetAMotorParam (joint, dParamStopCFM, 0.5);
	//dJointSetAMotorParam (joint, dParamStopERP, 0.9);
	dJointSetAMotorParam (joint, dParamFMax,    dInfinity);
}

void AMotor::set (char* name, char* value)
{

}
/*
void AMotorJoint::setAnchor (const Vector3& anchor)
{
	dJointSetAMotorAnchor (joint, anchor.x, anchor.y, anchor.z);
}
*/
void AMotor::setAxis (const int parameter, const Vector3& axis)
{
	dJointSetAMotorAxis (joint, parameter,1, axis.x, axis.y, axis.z);
}


void AMotor::setParam (int parameter, Real value)
{
  dJointSetAMotorParam (joint, parameter, value);

}

void AMotor::setNumAxes (int num)
{
  dJointSetAMotorNumAxes (joint, num);
}

void AMotor::setMode (int mode)
{
  dJointSetAMotorMode (joint, mode);
}

Real AMotor::getParam (int parameter) const
{
 return dJointGetAMotorParam(joint, parameter);
}


AMotor::~AMotor(){
  this->print();
  //this->getGraph()->removeConnection(this);
}

void AMotor::swap()
{
}

void AMotor::setIsEnabled (const bool isEnabled)
{
  Controller::setIsEnabled (isEnabled);
}


void AMotor::print() const
{
  printf ("SimJoint (AMOTOR): Enable=%i\n",this->isEnabled);
  Connection::print ();
}
