/*=========================================================================
UberSim Source Code Release
-------------------------------------------------------------------------
Copyright (C) 2002 Manuela Veloso, Brett Browning, Mike Bowling,
                   James Bruce; {mmv, brettb, mhb, jbruce}@cs.cmu.edu
                   Erick Tryzelaar {erickt}@andrew.cmu.edu
School of Computer Science, Carnegie Mellon University
-------------------------------------------------------------------------
This software is distributed under the GNU General Public License,
version 2.  If you do not have a copy of this licence, visit
www.gnu.org, or write: Free Software Foundation, 59 Temple Place,
Suite 330 Boston, MA 02111-1307 USA.  This program is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY,
including MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-------------------------------------------------------------------------*/

#ifndef __ENTITY_H__
#define __ENTITY_H__
/**
  * changes :
  *  - 22/6/03 MD Rien !
  *  - 17/7/03 hasHandledEvent
  *  - 11/9/03 MD Print
  */

class RigidBody;
class Event;
class MotionController;
class Spatial;
class Timer;

class Entity
{
  friend class Timer;

  public:
		virtual ~Entity ();

	public:
		MotionController* getMotionController ();
		Spatial*          getModel            ();
		
	public:
		virtual void think       ();
		virtual void touch       (Entity* entity);

		virtual void handleEvent (Event* event);
    virtual void print()=0;
		
		
	protected:
		Entity ();

	protected:
		MotionController* motionController;
		Spatial*          model;
    bool      hasHandledEvent;
};

#endif
