/***************************************************************************
                          HingeJoint.h  -  description
                             -------------------
    begin                : Mon Mar 17 2003
    copyright            : (C) 2003 by Yann Le-Guyadec et Michel Dubois
    email                : Yann.Le-Guyadec@univ-ubs.fr et Michel.Dubois@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __SIM_HINGEJOINT_H__
#define __SIM_HINGEJOINT_H__

#include "SimJoint.h"
#include "Vector3.h"
/**
  * changes :
  *  - 15/6/03 MD Creation !
  */

class SimRigidBody;

class HingeJoint : public SimJoint
{
	public:
		HingeJoint          (SimRigidBody * rigidBody1, SimRigidBody * RigidBody2);
		virtual ~HingeJoint ();

	public:
		void set (char * name, char * value);

		void setAnchor         (const Vector3& anchor);
		void setAxis          (const Vector3& axis1);
		void setMaxForce      (const Real     maxForce1);
		void setTargetVelocity (const Real     velocity);
    Real getAngle();
    Real getAngleRate();
    void setParam (const int odeparameter,const Real value);
    Real getParam (int odeparameter) const;
    void print() const;

};

#include "Joint.h"
#include "Vector3.h"
/**
  * changes :
  *  - 15/6/03 MD Creation !
  */

class RigidBody;

class OldHingeJoint : public Joint, public Connection, public Controller
{
	public:
		OldHingeJoint          (SimRigidBody * rigidBody1, SimRigidBody * RigidBody2);
		virtual ~OldHingeJoint ();

	public:
		void set (char * name, char * value);

		void setAnchor         (const Vector3& anchor);
		void setAxis          (const Vector3& axis1);
		void setMaxForce      (const Real     maxForce1);
		void setTargetVelocity (const Real     velocity);
    Real getAngle();
    Real getAngleRate();
    void setParam (const int odeparameter,const Real value);
    Real getParam (int odeparameter) const;
    void swap();
    void print() const;
    void setIsEnabled(bool isEnabled);


};

#endif
