/*=========================================================================
UberSim Source Code Release
-------------------------------------------------------------------------
Copyright (C) 2002 Manuela Veloso, Brett Browning, Mike Bowling,
                   James Bruce; {mmv, brettb, mhb, jbruce}@cs.cmu.edu
                   Erick Tryzelaar {erickt}@andrew.cmu.edu
School of Computer Science, Carnegie Mellon University
-------------------------------------------------------------------------
This software is distributed under the GNU General Public License,
version 2.  If you do not have a copy of this licence, visit
www.gnu.org, or write: Free Software Foundation, 59 Temple Place,
Suite 330 Boston, MA 02111-1307 USA.  This program is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY,
including MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-------------------------------------------------------------------------*/

#ifndef __SIM_JOINT_H__
#define __SIM_JOINT_H__

#include "nommgr.h"
#include <ode/ode.h>
#include "mmgr.h"
/**
  * changes :
  *  - 22/6/03 MD Rien !
  *  - 29/7/03 MD Joint ();
  */

class RigidBody;

class Joint
{
	public:
		virtual ~Joint ();

	public:
		RigidBody* getRigidBody1 ();
		RigidBody* getRigidBody2 ();
		
	protected:
    Joint ();
    Joint (RigidBody* rigidBody1, RigidBody* rigidBody2);

	protected:
		RigidBody* rigidBody1;
		RigidBody* rigidBody2;

		dJointID joint;
};

#endif
