/*=========================================================================
UberSim Source Code Release
-------------------------------------------------------------------------
Copyright (C) 2002 Manuela Veloso, Brett Browning, Mike Bowling,
                   James Bruce; {mmv, brettb, mhb, jbruce}@cs.cmu.edu
                   Erick Tryzelaar {erickt}@andrew.cmu.edu
School of Computer Science, Carnegie Mellon University
-------------------------------------------------------------------------
This software is distributed under the GNU General Public License,
version 2.  If you do not have a copy of this licence, visit
www.gnu.org, or write: Free Software Foundation, 59 Temple Place,
Suite 330 Boston, MA 02111-1307 USA.  This program is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY,
including MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-------------------------------------------------------------------------*/

#include "mmgr.h"

#include "PlaneGeometry.h"
/**
  * changes :
  *  - 22/6/03 Ajout methode print() !
  */


PlaneGeometry::PlaneGeometry (Vector3 normal, Real distance, char* name) : Geometry (name)
{
	this->normal   = normal;
	this->distance = distance;

	geometry  = dCreatePlane (0, normal.x, normal.y, normal.z, distance);
	
	modelBound = BoundingSphere (Vector3::ZERO, Math::INF);
}

PlaneGeometry::~PlaneGeometry ()
{
}

void PlaneGeometry::draw ()
{
}
void PlaneGeometry::print ()
{
  if (name)
  printf ("Plane Name: %s\n", name);
  else
  printf ("Plane anonyme\n");
   printf ("UBERSIM LP: %f %f %f WP: %f %f %f\n",
          getLocalPosition().x,
          getLocalPosition().y,
          getLocalPosition().z,
          getWorldPosition().x,
          getWorldPosition().y,
          getWorldPosition().z
  );
  printf ("ODE WP: Non placable Geom !\n");

}