/***************************************************************************
                          Sensor.h  -  description
                             -------------------
    begin                : ven jun 08 2003
    copyright            : (C) 2003 by Michel Dubois, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/*
  * changes :
  *  - 08/06/03 MD Creation !
  */


#ifndef __SENSOR__
#define __SENSOR__

namespace API {
/**
* Classe abstraite definissant un capteur
*
*@author Michel Dubois, Yann Le Guyadec
*@version du 08/06/03 (08 juin 2003)
*@since 0.2
*/
  class Sensor
  {
    public:
    
/**
	* retourne le mode d'activation du capteur
	* @return si le capteur est active
	*/
      bool getActivateMode() const;

/**
	* retourne la valeur brute du capteur
	* @return la valeur brute du capteur
	*/
      double getRawValue() const;
      
/**
	* affecte le mode d'activation du capteur
	* @param onoff mode d'activation
	*/
      void setActivateMode(bool onoff);

    protected:
/**
	* constructeur d'un capteur
	*
	*/
      Sensor();

/**
	* destructeur d'un capteur
	*
	*/
      virtual ~Sensor();

/**
	* affecte la valeur brute du capteur
	* @param aValue nouvelle valeur
	*/
      virtual void setRawValue(double aValue)=0;
      
    private:
      bool activateMode;
      double rawValue;
              
  };// END CLASS DEFINITION Sensor
}
#endif // __SENSOR__
