/***************************************************************************
                          simlink.cpp  -  description
                             -------------------
    begin                : ven jun 27 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "mmgr.h"
#include "SimLink.h"
#include "Timer.h"


#ifndef LEGLINK

SimLink::SimLink(SimLeg * aSimLeg, SimLeg * anotherSimLeg){
  this->sleg1=aSimLeg;
  this->sleg2=anotherSimLeg;
  this->linkjoint=0;
  if (sleg1->isConnectable(sleg2))
  {
    this->linkjoint=new HingeJoint(sleg1->body,sleg2->body);
    linkjoint->setAnchor(sleg1->getAbsPosEnd());
    linkjoint->setAxis(Vector3 (0,1,0));
    linkjoint->setParam(dParamLoStop,0);
    linkjoint->setParam(dParamHiStop,0);
    sleg1->bodyGeometry->setColor(Vector3(1,1,1));
    sleg2->bodyGeometry->setColor(Vector3(1,1,1));
  }
  /*
  printf("body1 orientation\n");
  sleg1->body->getWorldRotation().print();
  sleg1->body->getGraph()->print();
  printf("body2 orientation\n");
  sleg2->body->getWorldRotation().print();
  */
}

SimLink::~SimLink(){
  sleg1->bodyGeometry->setColor(sleg1->getColor());
  sleg2->bodyGeometry->setColor(sleg2->getColor());
  /*
  dBodySetForce(sleg1->body->getBody(),0,0,0);
  dBodySetForce(sleg2->body->getBody(),0,0,0);
  dBodySetTorque(sleg1->body->getBody(),0,0,0);
  dBodySetTorque(sleg2->body->getBody(),0,0,0);
  */
  if (linkjoint)      
    delete linkjoint;
  //sleg1->body->getGraph()->print();
  //sleg2->body->getGraph()->print();
  //Timer::getInstance ()->addEvent (sleg1, new FrameEvent (), 0);
  //Timer::getInstance ()->addEvent (sleg2, new FrameEvent (), 0);

  linkjoint=0;
  sleg1=0;
  sleg2=0;
}

#endif