/***************************************************************************
                          SimLinkedLeg.h  -  description
                             -------------------
    begin                : lun jui 21 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec 
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SIMLINKEDLEG_H
#define SIMLINKEDLEG_H
#include "SimLeg.h"
#include "SimRigidBody.h"

/**
  *@author Michel DUBOIS, Yann Le Guyadec 
  */
#ifdef LEGLINK
class SimLeg;
 
class SimLinkedLeg {
  private :
    SimLeg * sleg1;
    SimLeg * sleg2;

    SimRigidBody * linkBody;
    CylinderGeometry * linkGeometry;
    RigidBodyCollider * linkCollider;
    
  public:
	  SimLinkedLeg(SimLeg * aSimLeg, SimLeg * anotherSimLeg);
	  ~SimLinkedLeg();
    bool isConnectable();
    void link();
    void unlink();
    Vector3 getAbsPosEnd() const;
    Vector3 getAbsPosBody1() const;
    Vector3 getAbsPosBody2() const;


};
#endif


#endif
