/***************************************************************************
                          SimMolecule.cpp  -  description
                             -------------------
    begin                : mer jun 25 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "mmgr.h"
#include "SimMolecule.h"
#include "Event.h"
#include "RigidBody.h"
#include "Timer.h"
#include "Node.h"
#include "Engine.h"

CollisionGroup * SimMolecule::collisionGroup=0;


void SimMolecule::setCollisionGroup( CollisionGroup * aCollisionGroup){
  collisionGroup=aCollisionGroup;
}

SimMolecule::SimMolecule(){

  Node* molecule = new Node ("Molecule");
	this->model = molecule;

	rigidBody        = new RigidBody ();
	motionController = rigidBody;
	rigidBody->setModel (model);
  Engine::getInstance ()->getRoot ()->addChild (model);
	collisionGroup->addCollider(molecule);
      
}

SimMolecule::~SimMolecule()
{
  Timer::getInstance ()->clearEvents(this);
  collisionGroup->removeCollider(model);
  Engine::getInstance ()->getRoot ()->removeChild (model);  
}


void SimMolecule::addAtom(SimAtom * atom)
{

  Node * moleculeN=(Node *) this->model;
  moleculeN->addChild(atom->getModel());
    
}

void SimMolecule::removeAtom(SimAtom * atom)
{
  Node * moleculeN=(Node *) this->model;
  moleculeN->removeChild(atom->getModel());
}

void SimMolecule::handleEvent (Event* event)
{
	if (!event)
	{
		return;
	}

	////


	////

	RigidBodyEntity::handleEvent (event);
}
void SimMolecule::print()
{
  printf("SimMolecule: \n");
}
