/***************************************************************************
                          TouchSensor.h  -  description
                             -------------------
    begin                : dim jui 6 2003
    copyright            : (C) 2003 by Michel Dubois, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Modle statique
/*
  * changes :
  *  - 08/06/03 MD Creation !
  */


#ifndef __TOUCHSENSOR__
#define __TOUCHSENSOR__


// Include files
#include "Sensor.h"
#include "Leg.h"

//class Leg;

namespace API {
/**
* Classe definissant un capteur de contact
*
*@author Michel Dubois, Yann Le Guyadec
*@version du 08/06/03 (08 juin 2003)
*@since 0.2
*/

  class TouchSensor : public Sensor
  {
    public:
/**
	* retourne s'il y a un contact
  *
  * @return le capteur percoit un contact
	*/
      bool toBoolean() const;

/**
	* retourne la reference de la patte du capteur de contact courant
	*
	* @return l'instance de la patte qui est concernee par le capteur de contact
  	*/
      Leg * getLeg() const;

    protected:
/**
	* affecte la patte proprietaire du capteur de contact courant
	* @param aLeg reference du capteur de contact
	*/
      void setLeg(Leg * aLeg) ;

/**
	* constructeur d'un capteur de contact
	*
	*/
      TouchSensor();

/**
	* destructeur d'un capteur de contact
	*
	*/
      virtual ~TouchSensor();

private:

      Leg * leg;
          
  };// END CLASS DEFINITION TouchSensor
}
#endif // __TOUCHSENSOR__
