#!/bin/sh
# $Id: make_env.sh Exp $

version=0.2

if [ ! -z ${SIMATOMMODE} ] && [ "${SIMATOMMODE}" = "MULTI" ]; then
   	echo "Le simulateur est en mode multi-utilisateur"
	if [ -d /tmp/${LOGNAME}_frame ]; then
		rm -rf /tmp/${LOGNAME}_frame
	fi
	mkdir /tmp/${LOGNAME}_frame

	if [ -d /tmp/${LOGNAME}_video ]; then
		rm -rf /tmp/${LOGNAME}_video
	fi
	mkdir /tmp/${LOGNAME}_video

	if [ -d ${HOME}/simulatom-${version} ]; then
   		echo "Environnement de l'utilisateur deja cree."
	else
   		echo "Creation de l'environnement de l'utilisateur"
		mkdir ${HOME}/simulatom-${version}
		cd ${HOME}/simulatom-${version}
		ln -f -s /tmp/${LOGNAME}_frame frame			
		ln -f -s /tmp/${LOGNAME}_video video			
		if [ -f ${UBERSIMHOME}/setup.bash ] ; then
			ln -f -s ${UBERSIMHOME} UBERSIM
		fi
		if [ -f ${MPEG_ENCODEHOME}/setup.bash ] ; then
			ln -f -s ${MPEG_ENCODEHOME} MPEG_ENCODE
		fi
		if [ -f ${ODEHOME}/setup.bash ] ; then
			ln -f -s ${ODEHOME} ODE
		fi
		if [ -f ${EEHOME}/setup.bash ] ; then
			ln -f -s ${EEHOME} EE
		fi
		if [ -f ${SMPEGHOME}/setup.bash ] ; then
			ln -f -s ${SMPEGHOME} SMPEG
		fi

		ln -f -s ${SIMATOMHOME}/doc doc
#		ln -f -s ${SIMATOMHOME}/include include
		mkdir include
		cd ${SIMATOMHOME}/include
		for d in *.h ;do
			ln -s ${SIMATOMHOME}/include/$d ${HOME}/simulatom-${version}/include/$d     
   		done
		cd ${HOME}/simulatom-${version}
		mkdir lib
		cd lib
		ln -f -s ${SIMATOMHOME}/lib/libsimulatom.a libsimulatom.a
		ln -f -s ${SIMATOMHOME}/lib/libsimulatom.so libsimulatom.so
		cd ..
		mkdir bin
		cd bin
		ln -f -s ../frame frame
		ln -f -s ../memleaks.log memleaks.log	
		cd ..
		mkdir man
		cd man
		mkdir man1
		ln -f -s ${SIMATOMHOME}/man/man3 man3
		cd ..
		mkdir src
		cd src
		ln -f -s ${SIMATOMHOME}/src/simulatom simulatom
		cp -r ${SIMATOMHOME}/src/control .
		cd ..
		cp ${SIMATOMHOME}/Makefile* .
		cp ${SIMATOMHOME}/*.sh .
		cp ${SIMATOMHOME}/reference.* .
		cp ${SIMATOMHOME}/memleaks.* .
		cp -r ${SIMATOMHOME}/config .
		ln -f -s ${SIMATOMHOME}/README README
		ln -f -s ${SIMATOMHOME}/AUTHORS AUTHORS
		ln -f -s ${SIMATOMHOME}/COPYING COPYING
		ln -f -s ${SIMATOMHOME}/INSTALL INSTALL
		ln -f -s ${SIMATOMHOME}/TODO TODO
		ln -f -s ${SIMATOMHOME}/mpeg_param.txt mpeg_param.txt
		ln -f -s ${SIMATOMHOME}/setup.bash setup.bash
		ln -f -s ${SIMATOMHOME}/setup.tcsh setup.tcsh
		cp -r ${SIMATOMHOME}/workspace ${HOME}/simulatom-${version}
		make clean
		make
	fi
else
   echo "Le simulateur est en mode mono-utilisateur"
fi

