#!/bin/bash
# $Id: setup.bash Exp $
#
# Author : Michel Dubois
#

version=0.2

# IUP de Vannes
#basedir=/home/etud/projets/lsir01/prosir4

#Yann Le Guyadec
#basedir=/usr/local/produits

#IUT de Vannes
#basedir=/usr/local/alt/produits

#Michel DUBOIS
basedir=/home/simulatom

mode=MONO

if [ -z ${SIMATOMHOME} ]; then
    export SIMATOMMODE=${mode}
    export SIMATOMHOME=${basedir}/simulatom-${version}
    v=${version}
    if [ -f ${SIMATOMHOME}/UBERSIM/setup.bash ] ; then
	source ${SIMATOMHOME}/UBERSIM/setup.bash
    fi
    if [ -f ${SIMATOMHOME}/ODE/setup.bash ] ; then
	source ${SIMATOMHOME}/ODE/setup.bash
    fi
    if [ -f ${SIMATOMHOME}/MPEG_ENCODE/setup.bash ] ; then
	source ${SIMATOMHOME}/MPEG_ENCODE/setup.bash
    fi
    if [ -f ${SIMATOMHOME}/EE/setup.bash ] ; then
	source ${SIMATOMHOME}/EE/setup.bash
    fi
    if [ -f ${SIMATOMHOME}/SMPEG/setup.bash ] ; then
	source ${SIMATOMHOME}/SMPEG/setup.bash
    fi
    version=${v}
    if [ -f ${SIMATOMHOME}/make_env.sh ] ; then
    	${SIMATOMHOME}/make_env.sh
    fi
    if [ ! -z ${SIMATOMMODE} ] && [ "${SIMATOMMODE}" = "MULTI" ]; then
	export SIMATOMHOME=${HOME}/simulatom-${version}
    fi
    export SIMATOMCONFIG=${SIMATOMHOME}/config
    export PATH=${SIMATOMHOME}/bin:${PATH}
    export MANPATH=${SIMATOMHOME}/man:${MANPATH}
    export LD_LIBRARY_PATH=${SIMATOMHOME}/lib:${LD_LIBRARY_PATH}
else
    echo "Un environnement SIMULATOM ('${SIMATOMHOME}') est deja charge..."
fi
