#!/bin/tcsh
# $Id: setup.tcsh Exp $
#
# Author : Michel Dubois
#

set version=0.2

# IUP de Vannes
#set basedir=/home/etud/projets/lsir01/prosir4

# IUT de Vannes
#set basedir=/usr/local/alt/produits

# Michel Dubois
set basedir=/home/simulatom

# Yann Le Guyadec
#set basedir=/usr/local/produits

set mode=MONO

if ( ${?SIMATOMHOME} ) then
    echo "Un environnement SIMULATOM ('${SIMATOMHOME}') est deja charge..."
else
    setenv SIMATOMMODE ${mode}
    setenv SIMATOMHOME ${basedir}/simulatom-${version}
    set v=${version}
    if ( -f ${SIMATOMHOME}/UBERSIM/setup.tcsh ) then
	source ${SIMATOMHOME}/UBERSIM/setup.tcsh
    endif
    if ( -f ${SIMATOMHOME}/ODE/setup.tcsh ) then
	source ${SIMATOMHOME}/ODE/setup.tcsh
    endif
    if ( -f ${SIMATOMHOME}/MPEG_ENCODE/setup.tcsh ) then
	source ${SIMATOMHOME}/MPEG_ENCODE/setup.tcsh
    endif
    if ( -f ${SIMATOMHOME}/EE/setup.tcsh ) then
	source ${SIMATOMHOME}/EE/setup.tcsh
    endif
    if ( -f ${SIMATOMHOME}/SMPEG/setup.tcsh ) then
	source ${SIMATOMHOME}/SMPEG/setup.tcsh
    endif
    set version=${v}
    if ( -f ${SIMATOMHOME}/make_env.sh ) then
    	${SIMATOMHOME}/make_env.sh
    endif
    if ( ${?SIMATOMMODE} ) then
	if (${SIMATOMMODE} == 'MULTI') then
        	setenv SIMATOMHOME ${HOME}/simulatom-${version}
	endif
    endif
    setenv SIMATOMCONFIG ${SIMATOMHOME}/config
    setenv PATH ${SIMATOMHOME}/bin:${PATH}
    if ( ${?LD_LIBRARY_PATH} ) then
        setenv LD_LIBRARY_PATH ${SIMATOMHOME}/lib:${LD_LIBRARY_PATH}
    else
        setenv LD_LIBRARY_PATH ${SIMATOMHOME}/lib
    endif
    if ( ${?MANPATH} ) then
        setenv MANPATH ${SIMATOMHOME}/man:${MANPATH}
    else
        setenv MANPATH ${SIMATOMHOME}/man
    endif
endif
