/*=========================================================================
UberSim Source Code Release
-------------------------------------------------------------------------
Copyright (C) 2002 Manuela Veloso, Brett Browning, Mike Bowling,
                   James Bruce; {mmv, brettb, mhb, jbruce}@cs.cmu.edu
                   Erick Tryzelaar {erickt}@andrew.cmu.edu
School of Computer Science, Carnegie Mellon University
-------------------------------------------------------------------------
This software is distributed under the GNU General Public License,
version 2.  If you do not have a copy of this licence, visit
www.gnu.org, or write: Free Software Foundation, 59 Temple Place,
Suite 330 Boston, MA 02111-1307 USA.  This program is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY,
including MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-------------------------------------------------------------------------*/

#include "mmgr.h"

#include "Collision.h"
/**
  * changes :
  *  - 22/6/03 MD Rien !
  */

Collision::Collision (const Vector3& position, const Vector3& normal, const Real depth)
{
	this->position = position;
	this->normal   = normal;
	this->depth    = depth;
}

void Collision::print()
{
  printf("*** Collision:***\n");
  printf("Position.x: %f\n",position.x);
  printf("Position.y: %f\n",position.y);
  printf("Position.z: %f\n",position.z);
  printf("Normal.x: %f\n",position.x);
  printf("Normal.y: %f\n",position.y);
  printf("Normal.z: %f\n",position.z);
  printf("Depth: %f\n",depth);
  printf("Friction Direction.x: %f\n",contact->fdir1[0]);
  printf("Friction Direction.y: %f\n",contact->fdir1[1]);
  printf("Friction Direction.z: %f\n",contact->fdir1[2]);
	printf("Surface Parameter MODE: %i\n",contact->surface.mode);
  printf("Surface Parameter MU: %f\n",contact->surface.mu);
	printf("Surface Parameter MU2: %f\n",contact->surface.mu2);
	printf("Surface Parameter BOUNCE: %f\n",contact->surface.bounce);
	printf("Surface Parameter BOUNCE_VEL: %f\n",contact->surface.bounce_vel);
	printf("Surface Parameter SOFT_ERP: %f\n",contact->surface.soft_erp);
	printf("Surface Parameter SOFT_CFM: %f\n",contact->surface.soft_cfm);
	printf("Surface Parameter MOTION1: %f\n",contact->surface.motion1);
	printf("Surface Parameter MOTION2: %f\n",contact->surface.motion2);
	printf("Surface Parameter SLIP1: %f\n",contact->surface.slip1);
	printf("Surface Parameter SLIP2: %f\n",contact->surface.slip2);
  
}