/*=========================================================================
UberSim Source Code Release
-------------------------------------------------------------------------
Copyright (C) 2002 Manuela Veloso, Brett Browning, Mike Bowling,
                   James Bruce; {mmv, brettb, mhb, jbruce}@cs.cmu.edu
                   Erick Tryzelaar {erickt}@andrew.cmu.edu
School of Computer Science, Carnegie Mellon University
-------------------------------------------------------------------------
This software is distributed under the GNU General Public License,
version 2.  If you do not have a copy of this licence, visit
www.gnu.org, or write: Free Software Foundation, 59 Temple Place,
Suite 330 Boston, MA 02111-1307 USA.  This program is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY,
including MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-------------------------------------------------------------------------*/

#include "mmgr.h"

#include "Event.h"
/**
  * changes :
  *  - 22/6/03 MD Rien !
  *  - 14/7/03 MD des evenements
  *  - 11/9/03 Event
  */

Event::Event ()
{
  this->ID=0;
  this->syncIndex=0;
}

Event::~Event ()
{
}

KickerEvent::KickerEvent (const bool isEnabled)
{
	this->isEnabled = isEnabled;
}

DribblerEvent::DribblerEvent (const bool isEnabled)
{
	this->isEnabled = isEnabled;
}

PositionEvent::PositionEvent (const Vector3& position)
{
	this->position = position;
}

RotationEvent::RotationEvent (const Matrix33& rotation)
{
	this->rotation = rotation;
}

VelocityEvent::VelocityEvent (const Vector3& linearVelocity, const Vector3& angularVelocity)
{
	this->linearVelocity  = linearVelocity;
	this->angularVelocity = angularVelocity;
}

ServoMotorStopEvent::ServoMotorStopEvent ()
{

}

ServoMotorTargetPositionEvent::ServoMotorTargetPositionEvent (const int targetPosition)
{
	this->targetPosition = targetPosition;
}

ServoMotorTargetVelocityEvent::ServoMotorTargetVelocityEvent (const int targetVelocity)
{
  this->targetVelocity=targetVelocity;
}

