/***************************************************************************
                          Link.cpp  -  description
                             -------------------
    begin                : ven jun 27 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "mmgr.h"
#include "Link.h"

using namespace API;

Link::Link(Leg * aLeg, Leg * anotherLeg){
this->leg1=aLeg;
this->leg2=anotherLeg;
this->util=new Util(this);
#ifndef LEGLINK
  this->util->slink=new SimLink(aLeg->util->getSimulatedObject(), anotherLeg->util->getSimulatedObject());
#endif
#ifdef LEGLINK
  aLeg->util->getSimulatedObject()->link(anotherLeg->util->getSimulatedObject());
//  this->slink=new SimLinkedLeg(aLeg->getSimulatedObject(), anotherLeg->getSimulatedObject());
#endif

}

Link::Util::Util(Link * link)
{
 this->link=link;
 this->slink=0;
}
Link::Util::~Util()
{
#ifndef LEGLINK

  delete slink;
  slink=0;
#endif

}

Link::~Link(){
this->leg1->linkOfLeg=0;
this->leg2->linkOfLeg=0;
#ifdef LEGLINK
  this->leg1->util->getSimulatedObject()->unlink();
//  delete slink;
#endif
delete util;
}

Leg* Link::getLeg1() const{
  return leg1;
}

Leg* Link::getLeg2() const{
  return leg2;
}

bool Link::isUsing(Leg * aLeg) const{
  if ((this->leg1==aLeg) || (this->leg2==aLeg))
    return true;
  else
    return false;
}

Leg * Link::getOtherLeg(Leg * aLeg) const{
  if (this->leg1==aLeg)
    return leg2;
  if (this->leg2==aLeg)
    return leg1;
  return 0;
}

#ifndef LEGLINK        
SimLink * Link::Util::getSimulatedObject() const
{
  return this->slink;
}
#endif

Molecule * Link::getMolecule()  const
{
  return this->molecule;
}

void Link::setMolecule(Molecule * aMolecule)
{
  this->molecule=aMolecule;
}

void Link::swap()
{
  Leg * tmp=this->leg1;
  this->leg1=leg2;
  this->leg2=tmp;
}

void Link::Util::print() const
{
  printf ("Link Leg1: physicalID=%i atomID=%i\n",this->link->leg1->getID(), this->link->leg1->getAtom()->getID());
  printf ("Link Leg2: physicalID=%i atomID=%i\n",this->link->leg2->getID(), this->link->leg2->getAtom()->getID());
}

                                