/***************************************************************************
                          RayGeometry.cpp  -  description
                             -------------------
    begin                : dim jui 20 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec 
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef USE_OPENGL
#include <drawstuff/drawstuff.h>
#endif

#include "mmgr.h"

#include "RayGeometry.h"

/**
  * changes :
  *  - 20/7/03 Creation !
  */

RayGeometry::RayGeometry (Real length, char* name) : Geometry (name)
{
	this->length = length;

	geometry  = dCreateRay (0, length);

	modelBound = BoundingSphere (Vector3::ZERO, length * 0.5);
}

RayGeometry::~RayGeometry()
{
}

void RayGeometry::draw ()
{
#ifdef USE_OPENGL
	dsSetColor   (color.x, color.y, color.z);
	dsSetTexture (DS_WOOD);
/*
	dMatrix3 r;
	r[0]  = worldRotation[0][0];
	r[1]  = worldRotation[0][1];
	r[2]  = worldRotation[0][2];
	r[3]  = 0.0;
	r[4]  = worldRotation[1][0];
	r[5]  = worldRotation[1][1];
	r[6]  = worldRotation[1][2];
	r[7]  = 0.0;
	r[8]  = worldRotation[2][0];
	r[9]  = worldRotation[2][1];
	r[10] = worldRotation[2][2];
	r[11]  = 0.0;

	dsDrawCylinderD (worldPosition, r, length, 0.01);
*/
  /*
  dGeomRaySetLength (ray,0);
  dMakeRandomVector (q,3,1.0);
  dNormalize3 (q);
  for (j=0; j<3; j++) q[j] = 0.99*r * q[j] + p[j];
  dGeomSetPosition (ray,q[0],q[1],q[2]);
  dRFromAxisAndAngle (R,dRandReal()*2-1,dRandReal()*2-1,
		      dRandReal()*2-1,dRandReal()*10-5);
  dGeomSetRotation (ray,R);
  if (dCollide (ray,sphere,0,&contact,sizeof(dContactGeom)) != 0) FAILED();

*/
  dVector3 origin,dir;
  dGeomRayGet (geometry,origin,dir);
  dReal length = dGeomRayGetLength (geometry);
  for (int j=0; j<3; j++) dir[j] = dir[j]*length + origin[j];
  dsDrawLineD (origin,dir);
  dsSetColor (0,0,1);
  dsDrawSphereD (origin,dGeomGetRotation(geometry),0.01);
  

#endif
}

void RayGeometry::print ()
{
  if (name)
  printf ("Ray Name: %s\n", name);
  else
  printf ("Ray anonyme\n");
    printf ("UBERSIM LP: %f %f %f WP: %f %f %f\n",
          getLocalPosition().x,
          getLocalPosition().y,
          getLocalPosition().z,
          getWorldPosition().x,
          getWorldPosition().y,
          getWorldPosition().z
  );
  const dReal * pos=dGeomGetPosition(geometry);
  printf ("ODE WP: %f %f %f\n",
          pos[0],
          pos[1],
          pos[2]
  );


}
