/***************************************************************************
                          SimRigidBody.cpp  -  description
                             -------------------
    begin                : mar jui 29 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec 
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mmgr.h"
#include "SimRigidBody.h"
#include "Spatial.h"

SimRigidBody::SimRigidBody() : RigidBody()
{
  this->graph=new SimIsland();
  this->graph->addVertex(this);
  this->island=dynamic_cast<Island *>(graph);
}

SimRigidBody::~SimRigidBody()
{
  // Necessaire de bien faire la destruction
  // Avant le destructeur de RigidBody
  if (island)
	{
		if (island->getRigidBodyCount () <= 1)
		{
      
      island=0;
      delete graph;
      graph=0;
		}
		else
		{
			island->removeRigidBody (this);
		}
	}
}

void SimRigidBody::print ()
{
   if (getModel())
    printf ("SimRigidBody: Enable=%i Model=%s\n",getIsEnabled(),getModel()->getName());
   else
    printf ("SimRigidBody: Enable=%i\n",getIsEnabled());
/*
   if (island)
    printf ("Island: getCount()=%i\n",island->getRigidBodyCount());
   if (graph)
    printf ("SimIsland: getCount()=%i\n",graph->getVertexCount());
*/     
}

SimIsland * SimRigidBody::getSimIsland() const
{
  return dynamic_cast<SimIsland *> (getGraph());
}

void SimRigidBody::setSimIsland(SimIsland * aSimIsland)
{
  this->graph=aSimIsland;
  this->island=aSimIsland;
}

Island * SimRigidBody::getIsland() const
{
  return dynamic_cast<Island *> (getGraph());
}

void SimRigidBody::setIsland(Island * aIsland)
{
  SimIsland * tmp=dynamic_cast<SimIsland *> (aIsland);
  if (tmp)
    this->graph=tmp;
  this->island=aIsland;
}

void SimRigidBody::setIsEnabled (const bool isEnabled)
{
  Controller::setIsEnabled (isEnabled);
}

bool SimRigidBody::getIsEnabled () const
{
  return Controller::getIsEnabled ();
}