/***************************************************************************
                          Time.cpp  -  description
                             -------------------
    begin                : mar juin 8 2003
    copyright            : (C) 2003 by Michel DUBOIS, Yann Le Guyadec
    email                : Michel.Dubois@univ-ubs.fr, Yann.Le-Guyadec@univ-ubs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /**
  * changes :
  *  - 08/06/03 MD Creation !
  */

#include "mmgr.h"
#include "Time.h"

using namespace API;

Time::Time()
{
  this->second=0;
  this->minute=0;
  this->hour=0;
  this->day=0;
  this->month=0;
  this->year=0;
}

Time::Time(unsigned int sec, unsigned int min, unsigned int hour, unsigned int day, unsigned int month, unsigned int year)
{
  this->second=sec;
  this->minute=min;
  this->hour=hour;
  this->day=day;
  this->month=month;
  this->year=year;
}

Time::Time  (const Time * time)
{
  this->second=time->second;
  this->minute=time->minute;
  this->hour=time->hour;
  this->day=time->day;
  this->month=time->month;
  this->year=time->year;
}

Time::Time  (const Time& time)
{
  this->second=time.second;
  this->minute=time.minute;
  this->hour=time.hour;
  this->day=time.day;
  this->month=time.month;
  this->year=time.year;
}

Time::Time  (const unsigned int* time)
{
  this->second=time[0];
  this->minute=time[1];
  this->hour=time[2];
  this->day=time[3];
  this->month=time[4];
  this->year=time[5];
}

Time::~Time()
{
}
    
const Time& Time::operator = (const Time& time)
{
  this->second=time.second;
  this->minute=time.minute;
  this->hour=time.hour;
  this->day=time.day;
  this->month=time.month;
  this->year=time.year;

	return *this;
}

unsigned int& Time::operator [] (const unsigned int i) const
{
	return ((unsigned int*)this)[i];
}


Time::operator unsigned int* ()
{
	return (unsigned int*)this;
}
